﻿using Jd.Api;
using Jd.Api.Request;
using Jd.Api.Response;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.Net;
using System.IO;
using System.Diagnostics;
namespace jos_sdk_net_demo
{
    public partial class MainForm : Form
    {
        IJdClient client = null;
        Dictionary<string, string> dic = null;
        public MainForm()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string urlinfo = request_goodsRateUrl();
            string goodsinfo = request_goodsInfo();
            parseResult(urlinfo,goodsinfo);
        }

        private void parseResult(string urlinfo, string goodsinfo)
        {
            dataGridView1.Rows.Clear();
            pictureBox1.Image = null;
            string url = "";
            JObject obj = JObject.Parse(urlinfo);
            string queryjs_result = (string)obj["jingdong_service_promotion_getcode_responce"]["queryjs_result"];
            obj = JObject.Parse(queryjs_result);
            if ((int)obj["resultCode"] == 0)
            {
                url = (string)obj["url"];
                dataGridView1.Rows.Add(new object[]{"链接",url});
            }
            

            obj = JObject.Parse(goodsinfo);
            string getpromotioninfo_result = (string)obj["jingdong_service_promotion_goodsInfo_responce"]["getpromotioninfo_result"];
            obj = JObject.Parse(getpromotioninfo_result);
            if ((bool)obj["sucessed"])
            {
                obj = (JObject)obj["result"][0];
                dataGridView1.Rows.Add(new object[] { "商品名称", (string)obj["goodsName"] });
                dataGridView1.Rows.Add(new object[] { "商品编号", (string)obj["skuId"] });
                dataGridView1.Rows.Add(new object[] { "PC比率", (string)obj["commisionRatioPc"]+"%" });
                dataGridView1.Rows.Add(new object[] { "WL比率", (string)obj["commisionRatioWl"]+"%" });
                dataGridView1.Rows.Add(new object[] { "PC价格", "￥"+(string)obj["unitPrice"] });
                dataGridView1.Rows.Add(new object[] { "WL价格", "￥"+(string)obj["wlUnitPrice"] });
                WebRequest webreq = WebRequest.Create((string)obj["imgUrl"]);
                WebResponse webres = webreq.GetResponse();
                using(Stream stream = webres.GetResponseStream())
                {
                    pictureBox1.Image = Image.FromStream(stream);
                    pictureBox1.Tag = url;
                }
            }
        }
       
        private string request_goodsInfo()
        {
            ServicePromotionGoodsInfoRequest req = new ServicePromotionGoodsInfoRequest();
            req.skuIds = txtGoodsID.Text;
            ServicePromotionGoodsInfoResponse response = client.Execute(req, dic["token"], DateTime.Now.ToLocalTime());
            return response.Body;
        }

        private string request_goodsRateUrl()
        {
            ServicePromotionGetcodeRequest req = new ServicePromotionGetcodeRequest();

            req.promotionType = 7;
            req.materialId = "http://item.jd.com/"+txtGoodsID.Text+".html";
            req.unionId = long.Parse(dic["unionid"].ToString());
            req.channel = "PC";
            req.webId = dic["webid"].ToString();
            //req.extendId = "jingdong"; 
            //req.ext1 = "jingdong"; 
            //req.adttype = "6";
            //req.protocol = 0;//1为https,其他为http
            //req.pid = "jingdong";

            ServicePromotionGetcodeResponse response = client.Execute(req, dic["token"], DateTime.Now.ToLocalTime());
            return response.Body;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            JObject obj = JSONDataReader.LoadJson();
            dic = new Dictionary<string, string>();
            dic.Add("appkey",(string)obj["appkey"]);
            dic.Add("appsecret", (string)obj["appsecret"]);
            dic.Add("token", (string)obj["token"]);
            dic.Add("webid", (string)obj["webid"]);
            dic.Add("unionid", (string)obj["unionid"]);

            init_JDClient();
        }

        private void init_JDClient()
        {
            string url = "https://api.jd.com/routerjson";
            this.client = new DefaultJdClient(url, dic["appkey"].ToString(), dic["appsecret"].ToString());
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            if (pictureBox1.Tag != null)
            {
                Process.Start("http://devonios.com/jump/index.php?url=" + UrlEncode(pictureBox1.Tag.ToString()));
            }
        }

        private string UrlEncode(string str)
        {
            StringBuilder sb = new StringBuilder();
            byte[] byStr = System.Text.Encoding.UTF8.GetBytes(str); //默认是System.Text.Encoding.Default.GetBytes(str)
            for (int i = 0; i < byStr.Length; i++)
            {
                sb.Append(@"%" + Convert.ToString(byStr[i], 16));
            }

            return (sb.ToString());
        }

    }
}
